﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Text;
using System.Web.Script.Serialization;

public partial class _Default : System.Web.UI.Page
{


	protected void Page_Load(object sender, EventArgs e)
	{

	}
	protected void RadDockLayout1_SaveDockLayout(object sender, Telerik.Web.UI.DockLayoutEventArgs e)
	{
		HttpCookie dockState = Page.Response.Cookies.Get("MyApplicationDockStates");
		JavaScriptSerializer serializer = new JavaScriptSerializer();
		if (dockState == null)
		{
			dockState = new HttpCookie("MyApplicationDockStates");
			Page.Response.Cookies.Add(dockState);
		}
		List<DockState> stateList = ((RadDockLayout)sender).GetRegisteredDocksState();
		StringBuilder serializedList = new StringBuilder();
		for (int i = 0; i < stateList.Count; i++)
		{
			string serilizedState = serializer.Serialize(stateList[i]);
			serializedList.Append(serilizedState.ToString());
			serializedList.Append("|");
		}
		dockState.Expires = DateTime.Today.AddMonths(1);
		dockState.Value = serializedList.ToString();
	}
	protected void RadDockLayout1_LoadDockLayout(object sender, Telerik.Web.UI.DockLayoutEventArgs e)
	{
		HttpCookie dockState = Page.Request.Cookies.Get("MyApplicationDockStates");

		JavaScriptSerializer serializer = new JavaScriptSerializer();
		if (dockState != null)
		{
			string serializedList = dockState.Value;
			if (serializedList != null)
			{
				string[] states = serializedList.Split('|');
				for (int i = 0; i < states.Length; i++)
				{
					if (!string.IsNullOrEmpty(states[i]))
					{
						DockState state = serializer.Deserialize<DockState>(states[i]);
						RadDock dock = FindControl(state.UniqueName) as RadDock;
						if (dock != null) dock.ApplyState(state);
						e.Positions[state.UniqueName] = state.DockZoneID;
						e.Indices[state.UniqueName] = state.Index;
					}
				}
			}
		}
	}

	protected void RadXmlHttpPanel1_ServiceRequest(object sender, Telerik.Web.UI.RadXmlHttpPanelEventArgs e)
	{
		HttpCookie dockState = Page.Response.Cookies.Get("MyApplicationDockStates");
		if (dockState == null)
		{
			dockState = new HttpCookie("MyApplicationDockStates");
			Page.Response.Cookies.Add(dockState);
		}

		dockState.Expires = DateTime.Today.AddMonths(1);
		dockState.Value = e.Value.ToString();
		// the save state passed from the client is saved into a cookie, that will be used to recreate the RadDocks when the page is reloaded
	}
}